NPzT ensemble
=============

The barostat implemented in MW allows only to perform (isotropic) NPT simulations of 3D systems without electrodes. However, to equilibrate the density in a 2D box with electrodes, it is possible to consider the electrodes as pistons. To trigger this behaviour, use the keyword *piston* in the *electrode_type* block (see the [configuration instructions](system-configuration)).

In order to do this, the electrodes are treated as rigid bodies and the force exerted from both electrolyte and other electrode atoms on the electrode's center of mass is computed. An additional constant pressure force $`F = P \times S`$ is added to the electrode for them to act as pistons on the electrolyte.
The center of mass is given the total mass of the electrode and is time integrated using the Velocity Verlet algorithm. Therefore, the electrode atoms are only allowed to translate in the $`z`$ direction. It should be noted that the electrodes center of masses are not thermostatted.
