Ewald summation
===============

Ewald summation is a method for computing long-range interactions in periodic systems [[Ewald1921][1]]. In Metalwalls it is used for the Coulomb potential as well as the charge-dipole and the dipole-dipole interactions.

The Coulomb potential involves point charges and Gaussian charges as described [here](force-field). Two different periodic boundary conditions are implemented: 2D and 3D. The implementation is described in the pdf file *./doc/theory/ewald-summation/ewald.pdf*. It follows the derivation provided by Reed & Madden [[Reed2007][2]], with some minor corrections proposed by Gingrich & Wilson [[Gingrich2010][3]]. 

The charge-dipole and the dipole-dipole interactions, which are described [here](force-field), only involve point charges and 3D periodic boundary conditions in the current version of Metalwalls. The implementation follows the derivation provided by Aguado & Madden [[Aguado2003][4]]. 


References
----------
[1]:https://doi.org/10.1002/andp.19213690304
[Ewald1921]
P. P. Ewald.
Die Berechnung optischer und elektrostatischer Gitterpotentiale.
Ann. Phys. 369, 253 (1921)

[2]:https://doi.org/10.1063/1.2464084
[Reed2007]
S. K. Reed, O. J. Lanning and P. A. Madden.
Electrochemical interface between an ionic liquid and a model metallic electrode
J. Chem. Phys. 126, 084704 (2007)

[3]:https://doi.org/10.1016/j.cplett.2010.10.010
[Gingrich2010]
T. R. Gingrich and M. Wilson.
On the Ewald summation of Gaussian charges for the simulation of metallic surfaces.
Chem. Phys. Lett. 500, 178 (2010)

[4]:https://doi.org/10.1063/1.1605941
[Aguado2003]
A. Aguado and P. A. Madden
Ewald summation of electrostatic multipole interactions up to the quadrupolar level
J. Chem. Phys. 119, 7471 (2003)


