Examples
========

Several examples of input files are provided in the directory *./example/*.

**WARNING:** these files are provided as example only -- all the force field parameters should be carefully checked before considering production! 

blue-energy-cdc
---------------

2D cell with porous carbon electrodes (CDC) with an aqueous sodium chloride electrolyte.
NVT simulation at constant potential difference of 1V, solved using matrix inversion

Typical input from:
- Simoncelli, Ganfoud, Sene, Haefele, Daffos, Taberna, Salanne, Simon, Rotenberg,
Blue Energy and Desalination with Nanoporous Carbon Electrodes: Capacitance from Molecular Simulations to Continuous Models
Phys. Rev. X, 8, 021024, 2018
- Ganfoud, Sene, Haefele, Marin-LaflÃche, Daffos, Taberna, Salanne, Simon, Rotenberg,
Effect of the carbon microporous structure on the capacitance of aqueous supercapacitors
Energy Storage Materials, 21, 190, 2019

electric-field
--------------

3D box with a model electrode which has the structure of NaCl and an aqueous NaCl electrolyte.
NVT simulation at finite electric field, solved using conjugate gradient

Typical input from:
- Dufils, Jeanmairet, Rotenberg, Sprik, Salanne
Simulating Electrochemical Systems by Combining the Finite Field Method with a Constant Potential Electrode
Phys. Rev. Lett., 123, 195501, 2019

EMIM_BF4_graphene
-----------------

2D cell with 3 layers of carbon electrodes with a neat ionic liquid EMIM BF4
NPzT simulation at constant potential difference of 1V, applying a pressure force on the electrodes using the piston keyword,
solved using conjugate gradient.

EMIM_TFSI_bulk_no_polarizability
--------------------------------    

3D cell with neat EMIM-TFSI ionic liquid.
NVT simulation.

EMIM_TFSI_bulk_polarizability
-----------------------------       

3D cell with neat EMIM-TFSI ionic liquid.
NVT simulation including polarizability of the atoms.

Force field taken from:
-Goloviznina, Canongia Lopes, Costa Gomes, Padua
Transferable, Polarizable Force Field for Ionic Liquids
J. Chem. Theory Comput., 15, 5858, 2019

LiCl-aluminum 
-------------                      

2D box with planar aluminum electrodes with a molten salt electrolyte.
NVE simulation at constant potential difference
solved using MaZe with matrix inversion.

WARNING! The force field used for LiCl should be polarizable so this example may be used for testing purposes only

NaCl_PIM_NPT
------------  
                      
3D cell with polarizable NaCl and NPT ensemble

Typical input from:
- Ishii, Kasai, Salanne, Ohtori
Transport coefficients and the Stokes--Einstein relation in molten alkali halides with polarisable ion model
Mol. Phys., 113, 2442, 2015


nanoporous-graphene
-------------------                 

2D box with nanoporous planar carbon electrodes with an ionic liquid electrolyte.
NVT simulation at constant potential difference, solved using conjugate gradient

Typical input from:
- Mendez-Morales, Burbano, Haefele, Rotenberg, Salanne
Ion-Ion Correlations Across and Between Electrified Graphene Layers
J. Chem. Phys., 148, 193812, 2018
-Mendez-Morales, Ganfoud, Li, Haefele, Rotenberg, Salanne
Performance of microporous carbon electrodes for supercapacitors: Comparing graphene with disordered materials
Energy Storage Materials, 17, 88, 2019

plumed
------                              

2D cell with planar graphene electrodes at constant charges with water and a sodium ion.
NVT simulation with an additional constraint on the ion position using PLUMED.

polarizable-water
-----------------                   

3D cell with polarizable water.

python-piston-mgo 
-----------------                  

2D cell with planar MgO electrodes with a NaNO3 electrolyte, NPzT simulation.
Each electrode has to be defined twice, once for the Mg atoms and once for the O atoms. Therefore straightforward piston simulation cannot be done, and has to be run using the python interface.
These calculations work only for this specific system and force field. For large modifications (ie force field type), the python functions should be modified.

python-thermo_integration_charge
--------------------------------    

3D water box with an ion. Thermodynamic integration between a state of charge 0 to a state of charge 1, using U(l) = (1-l) U1 + l U2
These calculations work only for this specific system and force field. For modifications other than parameters (ie number of ION atoms, force field type...), the python functions should be modified.

python-thermo_integration_lj_lj
-------------------------------     

3D water box with an ion. Thermodynamic integration between different Lennard-Jones parameters, using U(l) = (1-l) U1 + l U2, using a linear combination of the Lennard-Jones parameters (only one force calculation is needed)
These calculations work only for this specific system and force field. For modifications other than parameters (ie number of ION atoms, force field type...), the python functions should be modified.

python-thermo_integration_lj_lj_brute_force
-------------------------------------------

3D water box with an ion. Thermodynamic integration between different Lennard-Jones parameters, using U(l) = (1-l) U1 + l U2, using linear combination of the forces
These calculations work only for this specific system and force field. For modifications other than parameters (ie number of ION atoms, force field type...), the python functions should be modified.

python-thermo_integration_soft_core
-----------------------------------

3D water box with a Lennard-Jones atom. Thermodynamic integration to insert the Lennard-Jones atom using a soft-core potential (as introduced in GROMACS)
These calculations work only for this specific system and force field. For modifications other than parameters (ie number of ION atoms, force field type...), the python functions should be modified.

steele-argon
------------                        

2D cell with non-structured Steele walls with a Lennard-Jones fluid (argon).
NPzT simulation, with pressure forces (piston) applied on the walls.

thomas-fermi-gold-capacitor
---------------------------   

2D box with planar gold electrodes, modelled with a
Thomas-Fermi length of 1.0 angstrom, with an aqueous sodium
chloride electrolyte. NVT simulation at constant potential
difference of 1V solved using matrix inversion.

Typical input from:
- Dufils, Scalfi, Rotenberg, Salanne
A semiclassical Thomas-Fermi model to tune the metallicity of electrodes in molecular simulations
arXiv, 1910.13341, 2019
