Ion deformation effects
=======================

MW implements the Aspherical Ion Model, with ion deformations up to the dipolar level (DAIM) [[Madden1996][1]].

The variables $`\{\sigma_i​,\nu_{ix},\nu_{iy},\nu_{iz}\}_{i\in N}`$ are introduced which represent the deviation of the ionic radius of the particle $`i`$ and the components of its distorsion in a dipolar shape, respectively. These are obtained through a minimization of the energy
```math
V(r_{ij}) = B^1_{ij}\exp(-\eta^1_{ij} r_{ij}) + B^2_{ij}\exp(-\eta^2_{ij} \rho_{ij}) + B^3_{ij}\exp(-\eta^3_{ij} \rho_{ij})
```
where

```math
\rho_{ij}=r_{ij}-\delta\sigma_{i}-\delta\sigma_{j} -\frac{1}{r_{ij}}\bm{r_{ij}}\cdot(\bm{\nu}_{i}-\bm{\nu}_{j})
```

Given the exponential form of the interactions, the minimization is performed by means of nonlinear conjugate gradient, as described in [[Press2007][2]].

References
----------
[1]:https://doi.org/10.1039/CS9962500339
[Madden1996]
P. A. Madden and M. Wilson.
'Covalent' effects in 'ionic' systems
Chem. Soc. Rev. 25, 339 (1996)

[2]:http://www.numerical.recipes
[Press2007]
W. Press, S. Teukolsky, W. Vetterling, and B. Flannery. 
Numerical recipes: the art of scientific computing. 
Cambridge, UK New York: Cambridge University Press (2007).