Time integration
=======================

Metalwalls uses the velocity-Verlet (VV) algorithm[[Swope1982][1]] to integrate the equations of motion. The integration scheme varies depending on the ensemble, the use of constraints, and the presence of constant potential electrodes:

* The following ensembles are available: [NVE](NVE-ensemble), [NVT](NVT-ensemble), [NPT](NPT-ensemble) and [NPzT](NPzT-ensemble). The computation of the temperature from the kinetic energy requires the definition of the number of degrees of freedom discussed [here](dof).
* The constraints are handled using the RATTLE algorithm [[Ryckaert1977][2] & [Andersen1983][3]]. Note that in the case of triatomic linear molecules a specific algorithm has to be used [[Ciccotti1982][4]], which is described in the pdf file *./doc/theory/RATTLE-linear-triatomic-molecules/rattle_linear_triatomic_molecule.pdf*
* For constant potential simulations, the calculation of the electrode atom charges is described [here](constant-potential).

* For polarizable force field simulations, the calculation of the electrolyte atom dipoles is described [here](polarization-effects).

* For DAIM force field simulations, the calculation of the electrolyte atom radii is described [here](ion-deformation-effects).

References
----------
[1]:https://doi.org/10.1063/1.442716
[Swope1982]
   W. C. Swope, H. C. Andersen, P. H. Berens and K. R. Wilson.
   A computer simulation method for the calculation of equilibrium constants for the formation of physical clusters of molecules: Application to small water clusters.
   J. Chem. Phys. 76, 637 (1982)

[2]:https://doi.org/10.1016/0021-9991(77)90098-5
[Ryckaert1977]
   J.-P. Ryckaert, G. Ciccotti and H. J. C. Berendsen.
   Numerical Integration of the Cartesian Equations of Motion of a System with Constraints: Molecular Dynamics of n-Alkanes.
   J. Comput. Phys. 23, 327 (1977)

[3]:https://doi.org/10.1016/0021-9991(83)90014-1
[Andersen1983]
   H. C. Andersen.
   Rattle: a 'velocity' version of the Shake algorithm for molecular dynamics calculations.
   J. Comput. Phys. 52, 24 (1983)

[4]:http://dx.doi.org/10.1080/00268978200100942
[Ciccotti1982]
   G. Ciccotti, M. Ferrario and J.-P. Ryckaert.
   Molecular dynamics of rigid systems in cartesian coordinates - A general formulation.
   Mol. Phys., 47, 1253 (1982)